GNU bug report logs - #52
FW: [mouse-1 in Customize should respect mouse-1-click-follows-link]

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: "Drew Adams" <drew.adams@HIDDEN>; merged with #15682; dated Tue, 11 Mar 2008 18:15:03 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Apr 2016 17:18:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 13:18:20 2016
Received: from localhost ([127.0.0.1]:50373 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avT6S-0004Ni-Of
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 13:18:20 -0400
Received: from aserp1040.oracle.com ([141.146.126.69]:45249)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>)
 id 1avT6Q-0004NR-Lk; Wed, 27 Apr 2016 13:18:18 -0400
Received: from aserv0022.oracle.com (aserv0022.oracle.com [141.146.126.234])
 by aserp1040.oracle.com (Sentrion-MTA-4.3.2/Sentrion-MTA-4.3.2) with ESMTP id
 u3RHICnQ013869
 (version=TLSv1 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
 Wed, 27 Apr 2016 17:18:12 GMT
Received: from userv0121.oracle.com (userv0121.oracle.com [156.151.31.72])
 by aserv0022.oracle.com (8.13.8/8.13.8) with ESMTP id u3RHIB1U004165
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
 Wed, 27 Apr 2016 17:18:12 GMT
Received: from abhmp0005.oracle.com (abhmp0005.oracle.com [141.146.116.11])
 by userv0121.oracle.com (8.13.8/8.13.8) with ESMTP id u3RHIAIs008429;
 Wed, 27 Apr 2016 17:18:11 GMT
MIME-Version: 1.0
Message-ID: <3c72ce34-13d3-4ecd-8731-8408fa1a023a@default>
Date: Wed, 27 Apr 2016 10:18:09 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: RE: bug#15682: 24.3.50; `:link' in `defgroup' does not respect
 `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
 <87inz3hw40.fsf@HIDDEN> <89237c28-b7ed-4621-9baf-908fe99a6c9d@default>
 <87potbgfia.fsf@HIDDEN>
In-Reply-To: <87potbgfia.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9  (901082) [OL
 12.0.6744.5000 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Source-IP: aserv0022.oracle.com [141.146.126.234]
X-Spam-Score: -3.3 (---)
X-Debbugs-Envelope-To: 52
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I kinda think it might be time to consider doing a rewrite from scratch
> using modern Emacs features, and then things like this bug report would
> start working automatically.
>=20
> How big a task would this be?  I mean, of course we'd keep compatibility
> (the defcustom language is fine), but just rewrite the UI `M-x
> customize' bits...  Hm...

I can't speak to this, sorry.  I'll just mention that I think:
(1) it could be a large undertaking and (2) there is existing
code out there that depends on or enhances cus*.el and wid*.el
code.

Personally, I would prefer that we live with it, and try to
improve it incrementally, rather than opting for a rewrite or
replacement.  I'd like to see a resident Emacs expert on wid*
and cus*, rather than someone who doesn't master it just trying
for a replacement.

(Yes, I'm conservative wrt this stuff.  Emacs is one of the
few things I'm conservative about. ;-))




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Apr 2016 16:53:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 12:53:22 2016
Received: from localhost ([127.0.0.1]:50343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avSiI-0000Sx-4n
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 12:53:22 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:46238)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1avSiG-0000Sm-EP; Wed, 27 Apr 2016 12:53:20 -0400
Received: from cm-84.215.1.64.getinternet.no ([84.215.1.64] helo=mouse)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>)
 id 1avSiD-0008Q2-Ld; Wed, 27 Apr 2016 18:53:19 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Drew Adams <drew.adams@HIDDEN>
Subject: Re: bug#15682: 24.3.50;
 `:link' in `defgroup' does not respect `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
 <87inz3hw40.fsf@HIDDEN>
 <89237c28-b7ed-4621-9baf-908fe99a6c9d@default>
Date: Wed, 27 Apr 2016 18:53:17 +0200
In-Reply-To: <89237c28-b7ed-4621-9baf-908fe99a6c9d@default> (Drew Adams's
 message of "Wed, 27 Apr 2016 09:24:34 -0700 (PDT)")
Message-ID: <87potbgfia.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 52
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Drew Adams <drew.adams@HIDDEN> writes:

> Dunno.  But just because the code can be difficult to follow
> is not a reason to assume that it does unnecessary things, in
> general.  The widget code that I've been able to follow does
> DTRT, generally (AFAICT).

It does, but the logic is very hard to follow.  Custom/widget works by
inserting text into the buffer, and then "converting" it to a widget, or
by creating a widget and then inserting it.  And it does it all with
overlays, and seems like it's created its own event handling distinct
from the normal Emacs event handler, sort of.

There are, of course, historical reasons for this.  Per wrote Widget in
the mid 90s when many of these issues hadn't been resolved, and it
worked across many Emacs versions.

I kinda think it might be time to consider doing a rewrite from scratch
using modern Emacs features, and then things like this bug report would
start working automatically.

How big a task would this be?  I mean, of course we'd keep compatibility
(the defcustom language is fine), but just rewrite the UI `M-x
customize' bits...  Hm...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Apr 2016 16:24:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 12:24:45 2016
Received: from localhost ([127.0.0.1]:50275 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avSGb-00089Y-KR
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 12:24:45 -0400
Received: from aserp1040.oracle.com ([141.146.126.69]:44793)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>)
 id 1avSGa-00089H-Tx; Wed, 27 Apr 2016 12:24:45 -0400
Received: from userv0022.oracle.com (userv0022.oracle.com [156.151.31.74])
 by aserp1040.oracle.com (Sentrion-MTA-4.3.2/Sentrion-MTA-4.3.2) with ESMTP id
 u3RGObO1001892
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Wed, 27 Apr 2016 16:24:37 GMT
Received: from userv0121.oracle.com (userv0121.oracle.com [156.151.31.72])
 by userv0022.oracle.com (8.14.4/8.13.8) with ESMTP id u3RGOa4C014598
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
 Wed, 27 Apr 2016 16:24:36 GMT
Received: from abhmp0005.oracle.com (abhmp0005.oracle.com [141.146.116.11])
 by userv0121.oracle.com (8.13.8/8.13.8) with ESMTP id u3RGOa37009821;
 Wed, 27 Apr 2016 16:24:36 GMT
MIME-Version: 1.0
Message-ID: <89237c28-b7ed-4621-9baf-908fe99a6c9d@default>
Date: Wed, 27 Apr 2016 09:24:34 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: RE: bug#15682: 24.3.50; `:link' in `defgroup' does not respect
 `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
 <87inz3hw40.fsf@HIDDEN>
In-Reply-To: <87inz3hw40.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9  (901082) [OL
 12.0.6744.5000 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Source-IP: userv0022.oracle.com [156.151.31.74]
X-Spam-Score: -3.3 (---)
X-Debbugs-Envelope-To: 52
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I've had another peek at this,=20

Thanks for looking into it.

> but the main problem is that I don't quite understand why the
> Widget code is so...  complicated.

I sympathize, and I agree that is difficult to fathom.
Can't help with the understanding, however.

> Why does it do all the stuff below?  I mean, no other modes
> that react to mouse clicks need to ... do all that...

Dunno.  But just because the code can be difficult to follow
is not a reason to assume that it does unnecessary things, in
general.  The widget code that I've been able to follow does
DTRT, generally (AFAICT).

I doubt that anyone left understands the widget code well.
Maybe you can find Per Abrahamsen and get him to take a look?
The URLs for him listed here are dead, but maybe looking here
would be a start: https://www.emacswiki.org/emacs/PerAbrahamsen.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Apr 2016 16:09:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 27 12:09:26 2016
Received: from localhost ([127.0.0.1]:50246 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1avS1m-00068S-Iw
	for submit <at> debbugs.gnu.org; Wed, 27 Apr 2016 12:09:26 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:45625)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1avS1k-00068G-1x; Wed, 27 Apr 2016 12:09:25 -0400
Received: from cm-84.215.1.64.getinternet.no ([84.215.1.64] helo=mouse)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>)
 id 1avS1f-0007qU-T0; Wed, 27 Apr 2016 18:09:23 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Drew Adams <drew.adams@HIDDEN>
Subject: Re: bug#15682: 24.3.50;
 `:link' in `defgroup' does not respect `mouse-1-click-follows-link'
References: <203eab8f-376f-423b-8347-3a0d354bb3e3@default>
Date: Wed, 27 Apr 2016 18:09:19 +0200
In-Reply-To: <203eab8f-376f-423b-8347-3a0d354bb3e3@default> (Drew Adams's
 message of "Tue, 22 Oct 2013 08:28:06 -0700 (PDT)")
Message-ID: <87inz3hw40.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 52
Cc: 15682 <at> debbugs.gnu.org, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Drew Adams <drew.adams@HIDDEN> writes:

> (defgroup foo nil
>   "..." :prefix "foo-" :group 'editing
>   :link '(url-link "http://www.emacswiki.org/"))
>
> (defcustom foobar t "..." :type 'boolean :group 'foo)
>
> M-x set-variable mouse-1-click-follows-link nil
> M-x customize-option foobar
>
> Click the link `http://www.emacswiki.org/' using `mouse-1'.  The link is
> followed - it should not be followed.
>
> Note that `mouse-on-link-p' returns `t' for positions on this link, and
> such positions have face `custom-link', property `follow-link' with
> value `mouse-face', and property `mouse-face' with a face value, all of
> which show further that the behavior violates the mandate of
> `mouse-1-click-follows-link'.

I've had another peek at this, but the main problem is that I don't
quite understand why the Widget code is so...  complicated.  Why does it
do all the stuff below?  I mean, no other modes that react to mouse
clicks need to ... do all that...

(defun widget-button-click (event)
  "Invoke the button that the mouse is pointing at."
  (interactive "e")
  (if (widget-event-point event)
      (let* ((oevent event)
	     (mouse-1 (memq (event-basic-type event) '(mouse-1 down-mouse-1)))
	     (pos (widget-event-point event))
	     (start (event-start event))
	     (button (get-char-property
		      pos 'button (and (windowp (posn-window start))
				       (window-buffer (posn-window start)))))
	     newpoint)
	(when (or (null button)
		  (catch 'button-press-cancelled
	      ;; Mouse click on a widget button.  Do the following
	      ;; in a save-excursion so that the click on the button
	      ;; doesn't change point.
	      (save-selected-window
		(select-window (posn-window (event-start event)))
		(save-excursion
		  (goto-char (posn-point (event-start event)))
		  (let* ((overlay (widget-get button :button-overlay))
			 (pressed-face (or (widget-get button :pressed-face)
					   widget-button-pressed-face))
			 (face (overlay-get overlay 'face))
			 (mouse-face (overlay-get overlay 'mouse-face)))


-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.
Merged 52 15682. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 17 Sep 2012 00:27:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 16 20:27:41 2012
Received: from localhost ([127.0.0.1]:37971 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TDPBc-0006tS-4Q
	for submit <at> debbugs.gnu.org; Sun, 16 Sep 2012 20:27:41 -0400
Received: from rcsinet15.oracle.com ([148.87.113.117]:34422)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1TDPBa-0006tL-3w
	for 52 <at> debbugs.gnu.org; Sun, 16 Sep 2012 20:27:38 -0400
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by rcsinet15.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id q8H0QPJ2017672
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Mon, 17 Sep 2012 00:26:26 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	q8H0QOfG008330
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Mon, 17 Sep 2012 00:26:25 GMT
Received: from abhmt107.oracle.com (abhmt107.oracle.com [141.146.116.59])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	q8H0QOH1029288; Sun, 16 Sep 2012 19:26:24 -0500
Received: from dradamslap1 (/10.159.170.142)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Sun, 16 Sep 2012 17:26:24 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Chong Yidong'" <cyd@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN><m3mxgr2uh8.fsf@HIDDEN><jwvbox7xjj7.fsf-monnier+emacs@HIDDEN><87oc15gbgk.fsf@HIDDEN><5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN><3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN><87bot0v209.fsf@HIDDEN><68D3F6DB97C842D2A3DF678198060FF6@HIDDEN><8762j7xist.fsf@HIDDEN>
	<623554DCCC824A97B672788F46A5F68C@HIDDEN>
Subject: RE: bug#52: FW: [mouse-1 in Customize
	shouldrespectmouse-1-click-follows-link]
Date: Sun, 16 Sep 2012 17:26:13 -0700
Message-ID: <8FB2DE2C46D14DED983CE4CC91FC7379@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <623554DCCC824A97B672788F46A5F68C@HIDDEN>
Thread-Index: AcyWs48JMi9Ug7odRGWT8Vv4LGZw9gAVJrxAP1i3M4A=
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-Spam-Score: -7.4 (-------)
X-Debbugs-Envelope-To: 52
Cc: 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -7.4 (-------)

ping





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 30 Oct 2011 14:48:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 30 10:48:50 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RKWgs-0005hs-9y
	for submit <at> debbugs.gnu.org; Sun, 30 Oct 2011 10:48:50 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RKWgp-0005hj-5X
	for 52 <at> debbugs.gnu.org; Sun, 30 Oct 2011 10:48:48 -0400
Received: from ucsinet22.oracle.com (ucsinet22.oracle.com [156.151.31.94])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9UEkcgd004561
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Sun, 30 Oct 2011 14:46:39 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by ucsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9UEkbb6010288
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Sun, 30 Oct 2011 14:46:38 GMT
Received: from abhmt110.oracle.com (abhmt110.oracle.com [141.146.116.62])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9UEkVhB007497; Sun, 30 Oct 2011 09:46:31 -0500
Received: from dradamslap1 (/10.159.56.18)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Sun, 30 Oct 2011 07:46:31 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Chong Yidong'" <cyd@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN><m3mxgr2uh8.fsf@HIDDEN><jwvbox7xjj7.fsf-monnier+emacs@HIDDEN><87oc15gbgk.fsf@HIDDEN><5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN><3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN><87bot0v209.fsf@HIDDEN><68D3F6DB97C842D2A3DF678198060FF6@HIDDEN>
	<8762j7xist.fsf@HIDDEN>
Subject: RE: bug#52: FW: [mouse-1 in Customize should
	respectmouse-1-click-follows-link]
Date: Sun, 30 Oct 2011 07:46:29 -0700
Message-ID: <623554DCCC824A97B672788F46A5F68C@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-reply-to: <8762j7xist.fsf@HIDDEN>
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
Thread-Index: AcyWs48JMi9Ug7odRGWT8Vv4LGZw9gAVJrxA
X-Source-IP: ucsinet22.oracle.com [156.151.31.94]
X-CT-RefId: str=0001.0A090203.4EAD6350.003D,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 52
Cc: 'Stefan Monnier' <monnier@HIDDEN>, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> I can't reproduce this.  With emacs -Q, and doing M-x customize,
> dragging `mouse-1' across (say) the "Undo edits" buffer selects that
> text, without enabling the button.

I see that too for emacs -Q.  So what?

1. _Clicking_, not dragging, mouse-1 on `Undo edits' or `INS' or `State' _does_
activate the button.  No matter how long you hold mouse-1 depressed.
`mouse-1-click-follows-links' is supposed to affect mouse-1 clicks, and a nil
value is supposed to return you to the same (sane) behavior Emacs had before Dev
started making mouse-1 follow links at all.

> Similarly for links.

No again.  In emacs -Q, with nil `mouse-1-click-follows-link', press mouse-1 on
`Hide' and hold it there as long or as short a time as you like (without
dragging). The `Hide' "link" is still followed (or the "button" is activated)
when you release the button.  Mouse-1 click is following links, in spite of the
option value.

2. To reproduce the problem as I reported it in doc strings, with emacs -Q:

(setq mouse-1-click-follows-link  nil)

(defcustom foo-fns ()
  "Some possibilities:
 `foobar', `toto'"
  :type '(repeat symbol) :group 'edit)

(defun foobar ()
  "Foobar's doc string"
  42)

M-x customize-option foo-fns

In the doc string, `foobar' is highlighted when you mouseover it.  It is a link.
Click mouse-1 on it (you might sometimes have to click twice, but not a
double-click).  Help opens.  QED.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 30 Oct 2011 03:27:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 29 23:27:20 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RKM3M-0002Jn-3T
	for submit <at> debbugs.gnu.org; Sat, 29 Oct 2011 23:27:20 -0400
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1RKM3J-0002Jg-VJ
	for 52 <at> debbugs.gnu.org; Sat, 29 Oct 2011 23:27:18 -0400
Received: from bb116-14-207-132.singnet.com.sg ([116.14.207.132]:36131
	helo=furball)
	by fencepost.gnu.org with esmtpsa (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.71) (envelope-from <cyd@HIDDEN>)
	id 1RKM1J-0001rZ-Vz; Sat, 29 Oct 2011 23:25:14 -0400
From: Chong Yidong <cyd@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: bug#52: FW: [mouse-1 in Customize should
	respectmouse-1-click-follows-link]
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
	<m3mxgr2uh8.fsf@HIDDEN>
	<jwvbox7xjj7.fsf-monnier+emacs@HIDDEN>
	<87oc15gbgk.fsf@HIDDEN>
	<5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN>
	<3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN>
	<87bot0v209.fsf@HIDDEN>
	<68D3F6DB97C842D2A3DF678198060FF6@HIDDEN>
Date: Sun, 30 Oct 2011 11:25:06 +0800
In-Reply-To: <68D3F6DB97C842D2A3DF678198060FF6@HIDDEN> (Drew Adams's
	message of "Sat, 29 Oct 2011 08:04:39 -0700")
Message-ID: <8762j7xist.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: 52
Cc: 'Stefan Monnier' <monnier@HIDDEN>, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

"Drew Adams" <drew.adams@HIDDEN> writes:

>>
>> Nothing prevents you from doing this.
>
> Yeah, how?  See what I wrote.  `mouse-1', held down for no matter how
> long, follows links and buttons in Customize.  It does not do this
> anywhere outside of Customize.

I can't reproduce this.  With emacs -Q, and doing M-x customize,
dragging `mouse-1' across (say) the "Undo edits" buffer selects that
text, without enabling the button.  Similarly for links.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 29 Oct 2011 15:06:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 29 11:06:48 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RKAUh-0001GO-UA
	for submit <at> debbugs.gnu.org; Sat, 29 Oct 2011 11:06:48 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RKAUf-0001GH-RN
	for 52 <at> debbugs.gnu.org; Sat, 29 Oct 2011 11:06:46 -0400
Received: from ucsinet22.oracle.com (ucsinet22.oracle.com [156.151.31.94])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9TF4h6W002670
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Sat, 29 Oct 2011 15:04:44 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9TF4gkY008627
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Sat, 29 Oct 2011 15:04:43 GMT
Received: from abhmt116.oracle.com (abhmt116.oracle.com [141.146.116.68])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9TF4agr001025; Sat, 29 Oct 2011 10:04:37 -0500
Received: from dradamslap1 (/10.159.53.80)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Sat, 29 Oct 2011 08:04:36 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Chong Yidong'" <cyd@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN><m3mxgr2uh8.fsf@HIDDEN><jwvbox7xjj7.fsf-monnier+emacs@HIDDEN><87oc15gbgk.fsf@HIDDEN><5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN><3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN>
	<87bot0v209.fsf@HIDDEN>
Subject: RE: bug#52: FW: [mouse-1 in Customize should
	respectmouse-1-click-follows-link]
Date: Sat, 29 Oct 2011 08:04:39 -0700
Message-ID: <68D3F6DB97C842D2A3DF678198060FF6@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <87bot0v209.fsf@HIDDEN>
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
Thread-Index: AcyV9brGXxeaykePRga92aoOx2v1WwAViztA
X-Source-IP: ucsinet22.oracle.com [156.151.31.94]
X-CT-RefId: str=0001.0A090206.4EAC160C.0082,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 52
Cc: 'Stefan Monnier' <monnier@HIDDEN>, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> > I want to be able to select text normally using mouse-1 and mouse-3
> > etc., including text that is linked.
> 
> Nothing prevents you from doing this.

Yeah, how?  See what I wrote.  `mouse-1', held down for no matter how long,
follows links and buttons in Customize.  It does not do this anywhere outside of
Customize.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 29 Oct 2011 04:48:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 29 00:48:24 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RK0qF-0005YF-SG
	for submit <at> debbugs.gnu.org; Sat, 29 Oct 2011 00:48:24 -0400
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1RK0qC-0005Y5-JB
	for 52 <at> debbugs.gnu.org; Sat, 29 Oct 2011 00:48:21 -0400
Received: from [155.69.18.173] (port=56621 helo=furball)
	by fencepost.gnu.org with esmtpsa (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.71) (envelope-from <cyd@HIDDEN>)
	id 1RK0oH-0000yA-Sj; Sat, 29 Oct 2011 00:46:22 -0400
From: Chong Yidong <cyd@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: bug#52: FW: [mouse-1 in Customize should
	respectmouse-1-click-follows-link]
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
	<m3mxgr2uh8.fsf@HIDDEN>
	<jwvbox7xjj7.fsf-monnier+emacs@HIDDEN>
	<87oc15gbgk.fsf@HIDDEN>
	<5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN>
	<3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN>
Date: Sat, 29 Oct 2011 12:46:14 +0800
In-Reply-To: <3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN> (Drew Adams's
	message of "Thu, 27 Oct 2011 14:28:20 -0700")
Message-ID: <87bot0v209.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -6.6 (------)
X-Debbugs-Envelope-To: 52
Cc: 'Stefan Monnier' <monnier@HIDDEN>, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.6 (------)

"Drew Adams" <drew.adams@HIDDEN> writes:

> I want to be able to select text normally using mouse-1 and mouse-3
> etc., including text that is linked.

Nothing prevents you from doing this.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Oct 2011 21:30:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 27 17:30:22 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RJXWn-00034P-HZ
	for submit <at> debbugs.gnu.org; Thu, 27 Oct 2011 17:30:22 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RJXWk-00034F-W3
	for 52 <at> debbugs.gnu.org; Thu, 27 Oct 2011 17:30:19 -0400
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9RLSQRR017116
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Thu, 27 Oct 2011 21:28:27 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9RLSOOE021997
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Thu, 27 Oct 2011 21:28:25 GMT
Received: from abhmt118.oracle.com (abhmt118.oracle.com [141.146.116.70])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9RLSJSt024061; Thu, 27 Oct 2011 16:28:19 -0500
Received: from dradamslap1 (/130.35.178.194)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Thu, 27 Oct 2011 14:28:19 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Chong Yidong'" <cyd@HIDDEN>,
	"'Stefan Monnier'" <monnier@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN><m3mxgr2uh8.fsf@HIDDEN><jwvbox7xjj7.fsf-monnier+emacs@HIDDEN><87oc15gbgk.fsf@HIDDEN>
	<5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN>
Subject: RE: bug#52: FW: [mouse-1 in Customize should
	respectmouse-1-click-follows-link]
Date: Thu, 27 Oct 2011 14:28:20 -0700
Message-ID: <3B7DF7BE86A64485BF3DD2AFD138AB6B@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN>
Thread-Index: Acw82JlVjryfk9VNSsGp39CQNPHAwhX/+o4wAAU74CAAAELLoA==
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-CT-RefId: str=0001.0A090206.4EA9CCFB.00AE,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 52
Cc: 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> Well, it turns out that that is no solution anyway.  If I do 
> that then even the real buttons (the rectangular, raised ones)
> in Customize do not react to mouse-1.
> 
> Sigh.
> 
> Why are links treated the same as buttons in Customize?  
> Maybe that's the question.  Dunno.

I want, as before, links to work only with mouse-2, but buttons and menu items
to work with mouse-1.  It seems that's no longer possible (?).

Using the hook I showed, I can use mouse-2 (only) for links (buttons too,
unfortunately), but it seems that mouse-1 (only) is hard-coded for menu items.
So I can use mouse-2 on the State button to open its menu, but then must switch
to mouse-1 to choose a menu item.

I want to be able to select text normally using mouse-1 and mouse-3 etc.,
including text that is linked.  I want to be able to click mouse-2 (only) to
follow links. I want to be able to use mouse-1 for both buttons and menu items.

This is nuts.  Why is it so messy?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Oct 2011 21:18:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 27 17:18:49 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RJXLc-0002nV-L3
	for submit <at> debbugs.gnu.org; Thu, 27 Oct 2011 17:18:49 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RJXLa-0002nN-6t
	for 52 <at> debbugs.gnu.org; Thu, 27 Oct 2011 17:18:47 -0400
Received: from acsinet21.oracle.com (acsinet21.oracle.com [141.146.126.237])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9RLGsTj004846
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Thu, 27 Oct 2011 21:16:54 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by acsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9RLGrf2006946
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Thu, 27 Oct 2011 21:16:53 GMT
Received: from abhmt117.oracle.com (abhmt117.oracle.com [141.146.116.69])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9RLGlVL000412; Thu, 27 Oct 2011 16:16:47 -0500
Received: from dradamslap1 (/130.35.178.194)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Thu, 27 Oct 2011 14:16:46 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Chong Yidong'" <cyd@HIDDEN>,
	"'Stefan Monnier'" <monnier@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN><m3mxgr2uh8.fsf@HIDDEN><jwvbox7xjj7.fsf-monnier+emacs@HIDDEN>
	<87oc15gbgk.fsf@HIDDEN> 
Subject: RE: bug#52: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
Date: Thu, 27 Oct 2011 14:16:47 -0700
Message-ID: <5AFC084D3F3B4EA38FFC527858157C0A@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: 
Thread-Index: Acw82JlVjryfk9VNSsGp39CQNPHAwhX/+o4wAAU74CA=
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: acsinet21.oracle.com [141.146.126.237]
X-Auth-Type: Internal IP
X-CT-RefId: str=0001.0A090205.4EA9CA47.001C,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 52
Cc: 'Lars Magne Ingebrigtsen' <larsi@HIDDEN>, 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

Well, it turns out that that is no solution anyway.  If I do that then even the
real buttons (the rectangular, raised ones) in Customize do not react to
mouse-1.

Sigh.

Why are links treated the same as buttons in Customize?  Maybe that's the
question.  Dunno.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 27 Oct 2011 21:15:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 27 17:15:40 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1RJXIa-0002j2-5Z
	for submit <at> debbugs.gnu.org; Thu, 27 Oct 2011 17:15:40 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1RJXIX-0002iv-UO
	for 52 <at> debbugs.gnu.org; Thu, 27 Oct 2011 17:15:39 -0400
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p9RLDjER001548
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK)
	for <52 <at> debbugs.gnu.org>; Thu, 27 Oct 2011 21:13:46 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p9RLDjhI003839
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <52 <at> debbugs.gnu.org>; Thu, 27 Oct 2011 21:13:45 GMT
Received: from abhmt113.oracle.com (abhmt113.oracle.com [141.146.116.65])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p9RLDdtj030924
	for <52 <at> debbugs.gnu.org>; Thu, 27 Oct 2011 16:13:39 -0500
Received: from dradamslap1 (/130.35.178.194)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Thu, 27 Oct 2011 14:13:39 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: <52 <at> debbugs.gnu.org>
Subject: FW: bug#52: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
Date: Thu, 27 Oct 2011 14:13:40 -0700
Message-ID: <80B268F1153A415BBB4A44BD9A6E2985@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
Thread-Index: Acw82JlVjryfk9VNSsGp39CQNPHAwhX/+o4wAAUlVWA=
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-CT-RefId: str=0001.0A020208.4EA9C98A.00FE,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.2 (------)
X-Debbugs-Envelope-To: 52
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.2 (------)

> From: Chong Yidong Sent: Thursday, July 07, 2011 12:03 PM
>
> Since Emacs 23, links in the Customize buffer have obeyed
> mouse-1-click-follows-link, via custom-mode-link-map.

So it's a regression starting in Emacs 23. ;-)

Actually, the binding is made in `widget-keymap', which is the grandparent of
`custom-mode-link-map'.  But I thought anyway, from looking at the code, that
`custom-mode-link-map' would be the right one to adjust, to change behavior for
this.  But apparently I was wrong - see below.

> The other widget buttons used by Customize, like the Exit button, are
> always activated with mouse-1, regardless of 
> mouse-1-click-follows-link.  But this is the correct behavior,
> since those are not links.
>
> So this is a zombie bug report.  I'm closing it.

You don't give users the choice (easily).  They should be able to control this
via `mouse-1-click-follows-link'.  They should not have to also modify
`custom-mode-link-map' (or, in face, `widget-keymap') directly.

Help buffers have links on function names etc.  Mouse-1 on those links respects
`mouse-1-click-follows-link'.  My code adds links also to function names etc. in
Customize doc strings - same idea as Help.  Those too should respect the user
option.

It's not even clear to me how to control this.  I tried this at first:

(add-hook 'Custom-mode-hook
          (lambda ()
           (define-key custom-mode-link-map
            [mouse-1] 'mouse-set-point)
           (define-key custom-mode-link-map
            [down-mouse-1] 'mouse-drag-region)))

And it didn't work, but I'm not sure why (still).
Keymap `custom-mode-link-map' correctly had this:

<down-mouse-1>  mouse-drag-region
<mouse-1>       mouse-set-point

But clicking mouse-1 on link/button text had this effect:

As soon as mouse-1 was pressed (not released), the face changed to an inset
(depressed) face.  And as soon as mouse-1 was released, the link was followed
(and the face restored).

The inset face looks like `custom-button-pressed', the local value of
`widget-button-pressed-face', and `widget-button-click' was in fact called
(why?).  The debugger said that `widget-button-click' was called interactively
(but it is not bound to any key).

If I did `C-u C-x =' on a link, the help said that the keymap property was nil,
the follow-link property was `mouse-face', and the button property was
`documentation-link (widget)Top'.

And mouse-1 was still bound to `mouse-set-point', etc.!  And it didn't matter
whether the click was quick or I held mouse-1 depressed for a while (to wait out
some timeout).

Actually, if I did something in another app and then came back and clicked
mouse-1 on a link, the first click _sometimes_ did nothing but set point, but
thereafter the other behavior returned (depressed-button face, follow link
etc.).  

This behavior is still a mystery to me.

I eventually got it done by binding the mouse keys in `widget-keymap' instead of
`custom-mode-link-map' in the hook.  Why I would need to do that, I have no
idea.  Do you have an idea?

What's clear is that it is not very clear how a user can easily prevent mouse-1
from following such links in Customize.

And I still don't understand why you don't let the option
`mouse-1-click-follows-link' control this, just as it does in all other buffers.
Why should Customize be handled differently from *Help* etc.?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.
Did not alter fixed versions and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.
bug unarchived. Request was from "Drew Adams" <drew.adams@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
bug archived. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.
bug closed, send any further explanations to 52 <at> debbugs.gnu.org and "Drew Adams" <drew.adams@HIDDEN> Request was from Chong Yidong <cyd@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 7 Jul 2011 19:03:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 07 15:03:32 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QetrI-0005OV-4v
	for submit <at> debbugs.gnu.org; Thu, 07 Jul 2011 15:03:32 -0400
Received: from vm-emlprdomr-05.its.yale.edu ([130.132.50.146])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1QetrG-0005OK-1y
	for 52 <at> debbugs.gnu.org; Thu, 07 Jul 2011 15:03:30 -0400
Received: from furball (dhcp128036225109.central.yale.edu [128.36.225.109])
	(authenticated bits=0)
	by vm-emlprdomr-05.its.yale.edu (8.14.4/8.14.4) with ESMTP id
	p67J3N6k026537
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES128-SHA bits=128 verify=NOT);
	Thu, 7 Jul 2011 15:03:24 -0400
From: Chong Yidong <cyd@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#52: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
	<m3mxgr2uh8.fsf@HIDDEN>
	<jwvbox7xjj7.fsf-monnier+emacs@HIDDEN>
Date: Thu, 07 Jul 2011 15:03:23 -0400
In-Reply-To: <jwvbox7xjj7.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Wed, 06 Jul 2011 16:09:50 -0400")
Message-ID: <87oc15gbgk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Scanned-By: MIMEDefang 2.71 on 130.132.50.146
X-Spam-Score: -2.7 (--)
X-Debbugs-Envelope-To: 52
Cc: Lars Magne Ingebrigtsen <larsi@HIDDEN>, 52 <at> debbugs.gnu.org,
	Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.7 (--)

The original report concerned only Emacs 22:

>> Click mouse-1 on a link in a Customize buffer that is a link to
>> another option name or similar. That is, on text between `' that is
>> highlighted with mouseover (`mouse-face').  The link is followed.
>>
>> In GNU Emacs 22.1.1 (i386-mingw-nt5.1.2600)
>>  of 2007-06-02 on RELEASE

Since Emacs 23, links in the Customize buffer have obeyed
mouse-1-click-follows-link, via custom-mode-link-map.

The other widget buttons used by Customize, like the Exit button, are
always activated with mouse-1, regardless of mouse-1-click-follows-link.
But this is the correct behavior, since those are not links.

So this is a zombie bug report.  I'm closing it.




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 7 Jul 2011 16:20:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 07 12:20:16 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QerJH-0002Ga-PU
	for submit <at> debbugs.gnu.org; Thu, 07 Jul 2011 12:20:16 -0400
Received: from hermes.netfonds.no ([80.91.224.195])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <larsi@HIDDEN>) id 1QerJF-0002GN-J0
	for 52 <at> debbugs.gnu.org; Thu, 07 Jul 2011 12:20:14 -0400
Received: from cm-84.215.51.58.getinternet.no ([84.215.51.58]
	helo=quimbies.gnus.org)
	by hermes.netfonds.no with esmtpsa (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.72) (envelope-from <larsi@HIDDEN>)
	id 1QerJ3-0005Lc-JI; Thu, 07 Jul 2011 18:20:01 +0200
From: Lars Magne Ingebrigtsen <larsi@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#52: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
In-Reply-To: <jwvbox7xjj7.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Wed, 06 Jul 2011 16:09:50 -0400")
Date: Thu, 07 Jul 2011 18:19:56 +0200
Message-ID: <m3box6xdub.fsf@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
	<m3mxgr2uh8.fsf@HIDDEN>
	<jwvbox7xjj7.fsf-monnier+emacs@HIDDEN>
User-Agent: Gnus/5.110018 (No Gnus v0.18) Emacs/24.0.50 (gnu/linux)
X-Now-Playing: The Smiths's _The World Won't Listen_: "Ask"
X-Hashcash: 1:23:110707:monnier@HIDDEN::lJZR8KfLVkvaFQBo:0000000000000000000000000000000000000572K
X-Hashcash: 1:23:110707:drew.adams@HIDDEN::8BlMOlsRfk+Jc6tM:00000000000000000000000000000000000000006Hpp
X-Hashcash: 1:23:110707:52 <at> debbugs.gnu.org::llNHay975L4A4Jbp:00000000000000000000000000000000000000000009ohi
MIME-Version: 1.0
Content-Type: text/plain
X-MailScanner-ID: 1QerJ3-0005Lc-JI
X-Netfonds-MailScanner: Found to be clean
X-Netfonds-MailScanner-From: larsi@HIDDEN
MailScanner-NULL-Check: 1310660401.88587@g5ZMwnYi3HNsloR6VBWaxg
X-Spam-Status: No
X-Spam-Score: -2.7 (--)
X-Debbugs-Envelope-To: 52
Cc: 52 <at> debbugs.gnu.org, Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.7 (--)

Stefan Monnier <monnier@HIDDEN> writes:

> I think in this present case, Custom should better follow Emacs
> conventions and hence only bind mouse-2 and then rely on the follow-link
> feature to make mouse-1 also work for those users who like it.

That sounds like a good idea.  I've had a go at doing this, but I'm
afraid I wasn't able to make it work.  Somebody who knows more about
`follow-link' and customize should have a look at it.

-- 
(domestic pets only, the antidote for overdose, milk.)
  bloggy blog http://lars.ingebrigtsen.no/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 6 Jul 2011 20:09:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jul 06 16:09:58 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QeYQ2-0004dM-No
	for submit <at> debbugs.gnu.org; Wed, 06 Jul 2011 16:09:58 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.183]
	helo=ironport2-out.pppoe.ca)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <monnier@HIDDEN>) id 1QeYQ0-0004d8-PJ
	for 52 <at> debbugs.gnu.org; Wed, 06 Jul 2011 16:09:57 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAIbAFE5FxIV4/2dsb2JhbABTqAd4iHrDGYY3BJ5rhC8
X-IronPort-AV: E=Sophos;i="4.65,488,1304308800"; d="scan'208";a="120715153"
Received: from 69-196-133-120.dsl.teksavvy.com (HELO pastel.home)
	([69.196.133.120])
	by ironport2-out.pppoe.ca with ESMTP/TLS/ADH-AES256-SHA;
	06 Jul 2011 16:09:50 -0400
Received: by pastel.home (Postfix, from userid 20848)
	id 99856592B6; Wed,  6 Jul 2011 16:09:50 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Lars Magne Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#52: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
Message-ID: <jwvbox7xjj7.fsf-monnier+emacs@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
	<m3mxgr2uh8.fsf@HIDDEN>
Date: Wed, 06 Jul 2011 16:09:50 -0400
In-Reply-To: <m3mxgr2uh8.fsf@HIDDEN> (Lars Magne Ingebrigtsen's
	message of "Wed, 06 Jul 2011 19:24:03 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.1 (--)
X-Debbugs-Envelope-To: 52
Cc: 52 <at> debbugs.gnu.org, Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.1 (--)

>>> Click mouse-1 on a link in a Customize buffer that is a link to
>>> another option name or similar. That is, on text between `' that is
>>> highlighted with mouseover (`mouse-face').  The link is followed.

Yes, Custom has always used mouse-1 clicks for that purpose, AFAIK.

> The actual key binding in these buffers for the mouse is:

> <down-mouse-1>	widget-button-click
> <down-mouse-2>	widget-button-click

> How is `mouse-1-click-follows-link' generally supposed to work?  Is

This is supposed to let mouse-1 clicks follow links otherwise only
accessible via mouse-2 clicks (i.e. when there's no binding for mouse-1
on this button/link).

It relies on the `follow-link' text-property and/or key binding to
specifies when this fallback is applicable.

That was introduced in reaction to people complaining about the
non-standard Emacs convention of using mouse-2 to follow links.
But actually some part of Emacs already used mouse-1 to follow links,
such as Customize, so these aren't affected by
mouse-1-click-follows-link.

I think in this present case, Custom should better follow Emacs
conventions and hence only bind mouse-2 and then rely on the follow-link
feature to make mouse-1 also work for those users who like it.


        Stefan




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 6 Jul 2011 17:32:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jul 06 13:32:31 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QeVxf-00076F-0R
	for submit <at> debbugs.gnu.org; Wed, 06 Jul 2011 13:32:31 -0400
Received: from acsinet15.oracle.com ([141.146.126.227])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1QeVxe-00075y-6m
	for 52 <at> debbugs.gnu.org; Wed, 06 Jul 2011 13:32:30 -0400
Received: from acsinet21.oracle.com (acsinet21.oracle.com [141.146.126.237])
	by acsinet15.oracle.com (Switch-3.4.4/Switch-3.4.4) with ESMTP id
	p66HWMuh028836
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Wed, 6 Jul 2011 17:32:23 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by acsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	p66HWL9d026931
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Wed, 6 Jul 2011 17:32:21 GMT
Received: from abhmt120.oracle.com (abhmt120.oracle.com [141.146.116.72])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	p66HWF40011892; Wed, 6 Jul 2011 12:32:15 -0500
Received: from dradamslap1 (/10.159.55.239)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Wed, 06 Jul 2011 10:32:15 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Lars Magne Ingebrigtsen'" <larsi@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
	<m3mxgr2uh8.fsf@HIDDEN>
Subject: RE: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
Date: Wed, 6 Jul 2011 10:32:13 -0700
Message-ID: <B1E9F356CC2A4F3C8AE5EE879EDA3BE3@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <m3mxgr2uh8.fsf@HIDDEN>
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6109
Thread-Index: Acw8AYyx5oZNZu/eSFqhmsyveIkkCAAAIM2w
X-Source-IP: acsinet21.oracle.com [141.146.126.237]
X-Auth-Type: Internal IP
X-CT-RefId: str=0001.0A090201.4E149C27.0224:SCFMA922111,ss=1,re=-4.000,fgs=0
X-Spam-Score: -4.4 (----)
X-Debbugs-Envelope-To: 52
Cc: 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.4 (----)

Thanks for looking at this, Lars.

I'm no expert on how this works or is supposed to work.

A (blind) guess would be that the problem is that these are perhaps not
considered to be "links" by the Customize code.  Dunno.

Emacs can be fussy about what it considers to be a link.  Some of the things
called "buttons" in the code are in fact links from a user viewpoint.  (But some
of them are not - they are truly action buttons.)

Someone more knowledgable than I will need to help here, I'm afraid.





Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.

Message received at 52 <at> debbugs.gnu.org:


Received: (at 52) by debbugs.gnu.org; 6 Jul 2011 17:24:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jul 06 13:24:22 2011
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1QeVpm-0006sf-2X
	for submit <at> debbugs.gnu.org; Wed, 06 Jul 2011 13:24:22 -0400
Received: from hermes.netfonds.no ([80.91.224.195])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <larsi@HIDDEN>) id 1QeVpk-0006sP-Mk
	for 52 <at> debbugs.gnu.org; Wed, 06 Jul 2011 13:24:21 -0400
Received: from cm-84.215.51.58.getinternet.no ([84.215.51.58]
	helo=quimbies.gnus.org)
	by hermes.netfonds.no with esmtpsa (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.72) (envelope-from <larsi@HIDDEN>)
	id 1QeVpZ-0007Yf-3X; Wed, 06 Jul 2011 19:24:09 +0200
From: Lars Magne Ingebrigtsen <larsi@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: FW: [mouse-1 in Customize should respect
	mouse-1-click-follows-link]
In-Reply-To: <001a01c883a2$b94cae10$0600a8c0@HIDDEN> (Drew Adams's
	message of "Tue, 11 Mar 2008 10:07:09 -0800")
Date: Wed, 06 Jul 2011 19:24:03 +0200
Message-ID: <m3mxgr2uh8.fsf@HIDDEN>
References: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
User-Agent: Gnus/5.110018 (No Gnus v0.18) Emacs/24.0.50 (gnu/linux)
X-Now-Playing: Demdike Stare's _Tryptych (3): Voices Of Dust_: "Past Is Past"
X-Hashcash: 1:23:110706:52 <at> debbugs.gnu.org::sTuCjgYdwWnDFtcv:0000000000000000000000000000000000000000000NTjX
X-Hashcash: 1:23:110706:drew.adams@HIDDEN::am9K8WRlfg9A2Rin:0000000000000000000000000000000000000000+xhC
MIME-Version: 1.0
Content-Type: text/plain
X-MailScanner-ID: 1QeVpZ-0007Yf-3X
X-Netfonds-MailScanner: Found to be clean
X-Netfonds-MailScanner-From: larsi@HIDDEN
MailScanner-NULL-Check: 1310577849.55022@yqK0kUWA0gGBpD7IHl6rag
X-Spam-Status: No
X-Spam-Score: -2.8 (--)
X-Debbugs-Envelope-To: 52
Cc: 52 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

"Drew Adams" <drew.adams@HIDDEN> writes:

> These are links. They should be controlled by `mouse-1-click-follows-link'.

[...]

>> Click mouse-1 on a link in a Customize buffer that is a link to
>> another option name or similar. That is, on text between `' that is
>> highlighted with mouseover (`mouse-face').  The link is followed.
>> 
>> The link should not be followed by `mouse-1' if
>> `mouse-1-click-follows-link' is nil.  In that case, only clicking
>> `mouse-2' should follow the link.

That sounds logical.

The actual key binding in these buffers for the mouse is:

<down-mouse-1>	widget-button-click
<down-mouse-2>	widget-button-click

How is `mouse-1-click-follows-link' generally supposed to work?  Is
`widget-button-click' supposed to not do its thing if
`mouse-1-click-follows-link' is nil?  That seems rather yucky.  Or is
the mode not supposed to bind `down-mouse-1' to anything if it's nil?

That variable is unknown to me.  The documentation says:

------
This feature only works in modes that specifically identify
clickable text as links, so it may not work with some external
packages.  See `mouse-on-link-p' for details.
------

Customize can't be said to be an "external package".  :-)  

`mouse-on-link-p' says:

------
A clickable link is identified by one of the following methods:

- If the character at POS has a non-nil `follow-link' text or
overlay property, the value of that property determines what to do.

- If there is a local key-binding or a keybinding at position POS
for the `follow-link' event, the binding of that event determines
what to do.
------

And the widget stuff does put `follow-link' on stuff.  So how is this
supposed to tie together?

-- 
(domestic pets only, the antidote for overdose, milk.)
  bloggy blog http://lars.ingebrigtsen.no/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#52; Package emacs. Full text available.
Severity set to `minor' from `normal' Request was from Don Armstrong <don@HIDDEN> to control@HIDDEN. Full text available.

Message received at (unknown):


Received: (at unknown) by unknown; unknown
X-Spam-Checker-Version: SpamAssassin 3.2.3-bugs.debian.org_2005_01_02
	(2007-08-08) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Status: No, score=-1.5 required=4.0 tests=AWL,FOURLA,MURPHY_WRONG_WORD1,
	MURPHY_WRONG_WORD2,RCVD_IN_DNSWL_MED,UNPARSEABLE_RELAY autolearn=ham
	version=3.2.3-bugs.debian.org_2005_01_02
Received: (at submit) by emacsbugs.donarmstrong.com; 11 Mar 2008 18:08:55 +0000
Received: from agminet01.oracle.com (agminet01.oracle.com [141.146.126.228])
	by rzlab.ucr.edu (8.13.8/8.13.8/Debian-3) with ESMTP id m2BI8pJe021192
	for <submit@HIDDEN>; Tue, 11 Mar 2008 11:08:52 -0700
Received: from agmgw2.us.oracle.com (agmgw2.us.oracle.com [152.68.180.213])
	by agminet01.oracle.com (Switch-3.2.4/Switch-3.1.7) with ESMTP id m2BI8OCN019598
	for <submit@HIDDEN>; Tue, 11 Mar 2008 13:08:24 -0500
Received: from acsmt351.oracle.com (acsmt351.oracle.com [141.146.40.151])
	by agmgw2.us.oracle.com (Switch-3.2.0/Switch-3.2.0) with ESMTP id m2A9K66I007617
	for <submit@HIDDEN>; Tue, 11 Mar 2008 12:08:24 -0600
Received: from inet-141-146-46-1.oracle.com by acsmt351.oracle.com
	with ESMTP id 3608095021205258832; Tue, 11 Mar 2008 11:07:12 -0700
Received: from dradamslap1 (/141.144.83.163)
	by bhmail.oracle.com (Oracle Beehive Gateway v4.0)
	with ESMTP ; Tue, 11 Mar 2008 11:07:12 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: <submit <at> debbugs.gnu.org>
Subject: FW: [mouse-1 in Customize should respect mouse-1-click-follows-link]
Date: Tue, 11 Mar 2008 10:07:09 -0800
Message-ID: <001a01c883a2$b94cae10$0600a8c0@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
Thread-Index: AciCaiTtcETn7tgbSAOYzCAKYTGDrQBOIzWQ
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.3198
X-Brightmail-Tracker: AAAAAQAAAAI=
X-Brightmail-Tracker: AAAAAQAAAAI=
X-Whitelist: TRUE
X-Whitelist: TRUE

 


-----Original Message-----
From: emacs-devel-bounces+drew.adams=oracle.com@HIDDEN
[mailto:emacs-devel-bounces+drew.adams=oracle.com@HIDDEN] On Behalf Of Drew
Adams
Sent: Sunday, March 09, 2008 8:50 PM
To: emacs-devel@HIDDEN
Cc: rms@HIDDEN
Subject: RE: [mouse-1 in Customize should respect
mouse-1-click-follows-link]

Resending.

These are links. They should be controlled by `mouse-1-click-follows-link'.


> From: Richard Stallman Sent: Friday, December 28, 2007 2:10 PM
> 
> What do people think of this issue?
>
>
> ------- Start of forwarded message -------
> From: "Drew Adams" <drew.adams@HIDDEN>
> To: "Bug-Gnu-Emacs" <bug-gnu-emacs@HIDDEN>
> Date: Wed, 26 Dec 2007 13:28:30 -0800
> Message-ID: <DHEEKFAFJEFOJHLCFPFDCECBCDAA.drew.adams@HIDDEN>
> MIME-Version: 1.0
> Content-Type: text/plain;
> 	charset="iso-8859-1"
> Subject: mouse-1 in Customize should respect 
> mouse-1-click-follows-link
> 
> Click mouse-1 on a link in a Customize buffer that is a link to
> another option name or similar. That is, on text between `' that is
> highlighted with mouseover (`mouse-face').  The link is followed.
> 
> The link should not be followed by `mouse-1' if
> `mouse-1-click-follows-link' is nil.  In that case, only clicking
> `mouse-2' should follow the link.
> 
> 
> In GNU Emacs 22.1.1 (i386-mingw-nt5.1.2600)
>  of 2007-06-02 on RELEASE
> Windowing system distributor `Microsoft Corp.', version 5.1.2600
> configured using `configure --with-gcc (3.4) --cflags 
> -Ic:/gnuwin32/include'








Acknowledgement sent to "Drew Adams" <drew.adams@HIDDEN>:
New bug report received and forwarded. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Report forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#52; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 27 Apr 2016 17:30:03 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.